// List with a context menu project template
import bb.cascades 1.0

Page {
    property variant exchangeRate

    titleBar: TitleBar {
        title : qsTr("Fix rate for ") + exchangeRate.code
    }

    Container {
        layout: StackLayout {
        }

        leftPadding: 10
        rightPadding: 10
        topPadding: 10
        bottomPadding: 10

        background: Color.create ("#F6F6F6")

        Container {
            layout: StackLayout {
                orientation: LayoutOrientation.LeftToRight
            }

            horizontalAlignment: HorizontalAlignment.Left

            ImageView {
                imageSource: "asset:///images/" + exchangeRate.code + ".png"
                preferredWidth: 328
                preferredHeight: 240

                horizontalAlignment: HorizontalAlignment.Left
            }

            Container {
                layout: StackLayout {}

                horizontalAlignment: HorizontalAlignment.Left

                leftMargin: 10

                Label {
                    text: exchangeRate.code

                    textStyle {
                        base: SystemDefaults.TextStyles.BigText
                        fontWeight: FontWeight.Bold
                    }

                    bottomMargin: 0
                    topMargin: 0
                }

                Label {
                    text: exchangeRate.country

                    textStyle {
                        base: SystemDefaults.TextStyles.TitleText
                    }

                    bottomMargin: 0
                    topMargin: 0
                }

                Label {
                    text: exchangeRate.currency

                    bottomMargin: 0
                    topMargin: 0

                    textStyle {
                        base: SystemDefaults.TextStyles.TitleText
                        color: Color.Gray
                        fontStyle: FontStyle.Italic
                    }
                }
            }
        }

        Label {
            text: "<b>" + exchangeRate.amount + "</b> " + exchangeRate.code + " = <b>" + exchangeRate.rate + "</b> CZK"

            textFormat: TextFormat.Html
        }

        TextField {
            id: amountTextField
            inputMode: TextFieldInputMode.NumbersAndPunctuation

            hintText: qsTr("Amount")
            clearButtonVisible: true

            input {
                submitKey: SubmitKey.Done
                submitKeyFocusBehavior: SubmitKeyFocusBehavior.Keep

                onSubmitted: {
                    resultLabel.text = exchangeDropDown.selectedIndex === 0 ? Math.round(amountTextField.text * exchangeRate.rate / exchangeRate.amount * 1000) / 1000 + " CZK" :
                                                                              Math.round(amountTextField.text / exchangeRate.rate * exchangeRate.amount * 1000) / 1000 + " " + exchangeRate.code;
                }
            }
        }

        DropDown {
            id: exchangeDropDown

            title : qsTr("Conversion")
            enabled : true

            Option {
                text : exchangeRate.code
                value : text
            }

            Option {
                text : "CZK"
                value : text
            }

            onSelectedIndexChanged: {
                resultLabel.text = exchangeDropDown.selectedIndex === 0 ? Math.round(amountTextField.text * exchangeRate.rate / exchangeRate.amount * 1000) / 1000 + " CZK" :
                                                                          Math.round(amountTextField.text / exchangeRate.rate * exchangeRate.amount * 1000) / 1000 + " " + exchangeRate.code;
            }
        }

        Label {
            id: resultLabel

            text: exchangeDropDown.selectedIndex === 0 ? Math.round(amountTextField.text * exchangeRate.rate / exchangeRate.amount * 1000) / 1000 + " CZK" :
            Math.round(amountTextField.text / exchangeRate.rate * exchangeRate.amount * 1000) / 1000 + " " + exchangeRate.code;

            textStyle {
                base: SystemDefaults.TextStyles.BigText
                fontWeight: FontWeight.Bold
            }
        }
    }

    onCreationCompleted: {
        // set default option to CZK
        exchangeDropDown.setSelectedIndex(0)
    }
}
