#include "CnbklBb10.hpp"
#include "ExchangeRatesDownloader.h"
#include "mylistmodel.hpp"
#include "ExchangeRateItemProvider.h"

#include <bb/cascades/Application>
#include <bb/cascades/QmlDocument>
#include <bb/cascades/AbstractPane>
#include <bb/cascades/SceneCover>

using namespace bb::cascades;

CnbklBb10::CnbklBb10(bb::cascades::Application *app)
: QObject(app)
{
    // create scene document from main.qml asset
    // set parent to created document to ensure it exists for the whole application lifetime
    QmlDocument *qml = QmlDocument::create("asset:///main.qml").parent(this);

    // register downloader and models
    qml->setContextProperty("_model", downloader.model());
    qml->setContextProperty("_topModel", downloader.topModel());
    qml->setContextProperty("_downloader", &downloader);

    // register scene cover
    qmlRegisterType<SceneCover>("bb.cascades", 1, 0, "SceneCover");
    qmlRegisterUncreatableType<AbstractCover>("bb.cascades", 1, 0, "AbstractCover", "An AbstractCover cannot be created.");

    // create root object for the UI
    AbstractPane *root = qml->createRootObject<AbstractPane>();
    // set created root object as a scene
    app->setScene(root);
}

