/*
 * ExchangeRateListItem.cpp
 *
 *  Created on: Dec 18, 2012
 *      Author: jreznik
 */

#include <bb/cascades/Container>
#include <bb/cascades/DockLayout>
#include <bb/cascades/FontSize>
#include <bb/cascades/ImageView>
#include <bb/cascades/Image>
#include <bb/cascades/Label>
#include <bb/cascades/StackLayout>
#include <bb/cascades/StackLayoutProperties>
#include <bb/cascades/SystemDefaults>
#include <bb/cascades/TextStyle>

using namespace bb::cascades;

#include "ExchangeRateListItem.h"

ExchangeRateListItem::ExchangeRateListItem(Container *parent)
: CustomControl(parent)
{
    Container *contents = new Container();
    StackLayout *contentsLayout = new StackLayout();
    contentsLayout->setOrientation(LayoutOrientation::LeftToRight);
    contents->setLayout(contentsLayout);

    // A background Container that will hold a background image and a item content Container.
    Container *backgroundContainer = new Container();
    backgroundContainer->setPreferredHeight(141);
    DockLayout *backgroundLayout = new DockLayout();
    backgroundContainer->setLayout(backgroundLayout);
    backgroundContainer->setHorizontalAlignment(HorizontalAlignment::Fill);

//    m_highlighContainer = new ImageView();
//    m_highlighContainer->setImage(Image(QUrl("asset:///images/highlighted.png")));
//    m_highlighContainer->setOpacity(0.0);

//    m_itemImage = new ImageView();
//    m_itemImage->setLayoutProperties(StackLayoutProperties::create());
//    m_itemImage->setMinWidth(128.0f);
//    m_itemImage->setMinHeight(128.0f);

    Container *textContents = new Container();
    m_itemCurrency = Label::create();
    m_itemCurrency->textStyle()->setBase(SystemDefaults::TextStyles::titleText());
    m_itemCurrency->textStyle()->setColor(Color::Black);

//    m_itemDescription = Label::create();
//    m_itemDescription->textStyle()->setBase(SystemDefaults::TextStyles::smallText());
//    m_itemDescription->textStyle()->setColor(Color::Black);
//    m_itemDescription->textStyle()->setFontSize(FontSize::Medium);

    //contents->add(m_itemImage);
    contents->add(textContents);
    textContents->add(m_itemCurrency);
    //textContents->add(m_itemDescription);

//    backgroundContainer->add(m_highlighContainer);
    backgroundContainer->add(contents);

    setRoot(backgroundContainer);
}

void ExchangeRateListItem::setCurrencyText(const QString &currencyText)
{
    m_itemCurrency->setText(currencyText);
}

void ExchangeRateListItem::select(bool select)
{
	Q_UNUSED(select);
}

void ExchangeRateListItem::reset(bool selected, bool activated)
{
	Q_UNUSED(activated);

	select(selected);
}

void ExchangeRateListItem::activate(bool activate)
{
	select(activate);
}
