#ifndef EXCHANGERATESDOWNLOADER_H
#define EXCHANGERATESDOWNLOADER_H

#include <QObject>

#include <bb/cascades/GroupDataModel>

#include "ExchangeRateItem.h"


namespace bb
{
namespace cascades
{
class Control;
class QmlDocument;
}
}

class ExchangeRatesDownloader : public QObject
{
    Q_OBJECT

    Q_PROPERTY(bool firstItemLoaded READ firstItemLoaded NOTIFY firstItemLoadedChanged FINAL)
    Q_PROPERTY(QString loadedDate READ loadedDate NOTIFY loadedDateChanged FINAL)
public:
    explicit ExchangeRatesDownloader(QObject *parent = 0);

    Q_INVOKABLE void load(const QString formattedDate);

    bb::cascades::GroupDataModel *model();
    bb::cascades::GroupDataModel *topModel();
    
signals:
    
public slots:

Q_SIGNALS:
    void firstItemLoadedChanged(bool loaded);
    void loadedDateChanged(QString date);

private:
    double firstItemLoaded() const {
        return m_firstItemLoaded;
    }

    QString loadedDate() const {
        return m_date;
    }

    bb::cascades::GroupDataModel *m_model;
    bb::cascades::GroupDataModel *m_topModel;

    QNetworkAccessManager *m_manager;

    QString m_date;
    QString m_revision;

    bool m_firstRun;

    bool m_firstItemLoaded;

private slots:
    void requestFinished();
};

#endif // EXCHANGERATESDOWNLOADER_H
